/*!
 * Leaflet.CustomLayer.js v1.0.0
 * 
 * Copyright (c) 2019-present Derek Li
 * Released under the MIT License - https://choosealicense.com/licenses/mit/
 * 
 * https://github.com/iDerekLi/Leaflet.CustomLayer
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("leaflet")):"function"==typeof define&&define.amd?define(["exports","leaflet"],t):t(((e=e||self).Leaflet=e.Leaflet||{},e.Leaflet.CustomLayer={}),e.L)}(this,function(e,t){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function n(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function o(e,t,i){return t&&n(e.prototype,t),i&&n(e,i),e}function s(e,t,i){return t in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function r(e){for(var t=1;t<arguments.length;t++){var i=null!=arguments[t]?arguments[t]:{},n=Object.keys(i);"function"==typeof Object.getOwnPropertySymbols&&(n=n.concat(Object.getOwnPropertySymbols(i).filter(function(e){return Object.getOwnPropertyDescriptor(i,e).enumerable}))),n.forEach(function(t){s(e,t,i[t])})}return e}function a(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&h(e,t)}function l(e){return(l=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function h(e,t){return(h=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function u(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function m(e,t){return!t||"object"!=typeof t&&"function"!=typeof t?u(e):t}t=t&&t.hasOwnProperty("default")?t["default"]:t;var y=function(e){function n(e){var o;i(this,n),o=m(this,l(n).call(this,e));var s=r({el:null,zooms:[0,18],opacity:1,visible:!0,zIndex:120,alwaysRender:!0,layerWillMount:null,layerDidMount:null,layerRender:null,layerWillUnmount:null,layerDidUnmount:null},e),a={el:s.el,opacity:s.opacity,visible:s.visible,zIndex:s.zIndex,zooms:s.zooms,alwaysRender:s.alwaysRender};return t.setOptions(u(o),a),"function"==typeof s.layerWillMount&&(o.layerWillMount=s.layerWillMount),"function"==typeof s.layerDidMount&&(o.layerDidMount=s.layerDidMount),"function"==typeof s.layerRender&&(o.layerRender=s.layerRender),"function"==typeof s.layerWillUnmount&&(o.layerWillUnmount=s.layerWillUnmount),"function"==typeof s.layerDidUnmount&&(o.layerDidUnmount=s.layerDidUnmount),o}return a(n,t.Layer?t.Layer:t.Class),o(n,[{key:"beforeAdd",value:function(e){this._map=e,this._registerEvents=!1,this._eventType="",this._zoomVisible=!0,this.getElement()&&this._animateZoom({center:this._map.getCenter(),zoom:this._map.getZoom(),noUpdate:undefined,type:"zoomanim",target:this._map,sourceTarget:this._map}),this.layerWillMount&&this.layerWillMount.bind(this)()}},{key:"getEvents",value:function(){this._registerEvents=!0;var e={resize:this._onLayerResize,movestart:this._onLayerMovestart,move:this._onLayerMove,moveend:this._onLayerMoveend,zoomstart:this._onLayerZoomstart,zoom:this._onLayerZoom,zoomend:this._onLayerZoomend};return this._map.options.zoomAnimation&&t.Browser.any3d&&(e.zoomanim=this._onLayerZoomanim),e}},{key:"onAdd",value:function(e){this._map=e;var t=this.getElement();this._addElement(t),this.layerDidMount&&this.layerDidMount.bind(this)(),this.options.visible||this.hide(),this._needRedraw()}},{key:"onRemove",value:function(e){this.layerWillUnmount&&this.layerWillUnmount.bind(this)(),this._removeElement(this.getElement()),this._registerEvents&&(this._registerEvents=!1,this._map.off(this.getEvents(),this)),this._map.off({zoom:this._onZoomVisible},this),this.layerDidUnmount&&this.layerDidUnmount.bind(this)()}},{key:"_render",value:function(){this.layerRender&&this.layerRender.bind(this)(),this._frame=null}},{key:"_onLayerResize",value:function(e){""===this._eventType&&(this._eventType="resize","resize"===this._eventType&&(this._setElementSize(e.newSize),this._setElementPosition(),this._render(),this._eventType=""))}},{key:"_onLayerMovestart",value:function(e){""===this._eventType&&(this._eventType="move",this._eventType)}},{key:"_onLayerMove",value:function(e){"move"===this._eventType&&this.options.alwaysRender&&(this._setElementPosition(),this._render())}},{key:"_onLayerMoveend",value:function(e){"move"===this._eventType&&(this._setElementPosition(),this._render(),this._eventType="")}},{key:"_onLayerZoomstart",value:function(e){""===this._eventType&&(this._eventType="zoom",this._eventType)}},{key:"_onLayerZoomanim",value:function(e){"zoom"===this._eventType&&this._animateZoom(e)}},{key:"_onLayerZoom",value:function(e){if("zoom"===this._eventType&&this.options.alwaysRender){if(!this._isZoomVisible())return this._zoomHide(),void(this._eventType="");this._setElementPosition(),this._render()}}},{key:"_onLayerZoomend",value:function(e){if("zoom"===this._eventType){if(!this._isZoomVisible())return this._zoomHide(),void(this._eventType="");this._setElementPosition(),this._render(),this._eventType=""}}},{key:"_onZoomVisible",value:function(){this._isZoomVisible()?this._zoomShow():this._zoomHide()}},{key:"_needRedraw",value:function(){return this._frame||(this._frame=t.Util.requestAnimFrame(this._render,this)),this}},{key:"_addElement",value:function(e){console.log(e);var i=this._map.getSize();this._setElementSize(i),this.setOpacity(this.options.opacity),this.setZIndex(this.options.zIndex);var n=this._map.options.zoomAnimation&&t.Browser.any3d;t.DomUtil.addClass(e,"leaflet-layer"),t.DomUtil.addClass(e,"leaflet-zoom-".concat(n?"animated":"hide")),this._registerEvents||this._map.on(this.getEvents(),this),this.options.visible?this._map.getPanes().overlayPane.appendChild(e):this._map.off(this.getEvents(),this)}},{key:"_removeElement",value:function(e){this._frame&&(t.Util.cancelAnimFrame(this._frame),this._frame=null);try{this._map.getPanes().overlayPane.removeChild(e)}catch(i){}}},{key:"_setElementSize",value:function(e){var t=this.getElement();t.setAttribute("width",e.x),t.setAttribute("height",e.y),t.style.width=e.x+"px",t.style.height=e.y+"px"}},{key:"_setElementPosition",value:function(){var e=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[0,0],i=this._map.containerPointToLayerPoint(e);t.DomUtil.setPosition(this.getElement(),i)}},{key:"_setTransform",value:function(e,i,n){var o=i||new t.Point(0,0);e.style[t.DomUtil.TRANSFORM]=(t.Browser.ie3d?"translate(".concat(o.x,"px, ").concat(o.y,"px)"):"translate3d(".concat(o.x,"px, ").concat(o.y,"px, 0)"))+(n?" scale(".concat(n,")"):"")}},{key:"_animateZoom",value:function(e){var i=this._map.getZoomScale(e.zoom),n=t.Layer?this._map._latLngBoundsToNewLayerBounds(this._map.getBounds(),e.zoom,e.center).min:this._map._getCenterOffset(e.center)._multiplyBy(-i).subtract(this._map._getMapPanePos());(t.DomUtil.setTransform||this._setTransform)(this.getElement(),n,i)}},{key:"_isZoomVisible",value:function(){var e=this.options.zooms[0],t=this.options.zooms[1],i=this._map.getZoom();return i>=e&&i<=t}},{key:"_zoomShow",value:function(){this._zoomVisible||(this._zoomVisible=!0,this._map.off({zoom:this._onZoomVisible},this),this.options.visible&&(this._map.on(this.getEvents(),this),this._map.getPanes().overlayPane.appendChild(this.getElement()),this._setElementPosition(),this._render()))}},{key:"_zoomHide",value:function(){if(this._zoomVisible){this._zoomVisible=!1,this._map.off(this.getEvents(),this),this._map.on({zoom:this._onZoomVisible},this);try{this._map.getPanes().overlayPane.removeChild(this.getElement())}catch(e){}}}},{key:"addTo",value:function(e){return e.addLayer(this),this}},{key:"getElement",value:function(){return this.options.el}},{key:"setElement",value:function(e){var t=this.getElement();return this.options.el=e,this._removeElement(t),this._addElement(e),this._setElementPosition(),this._render(),e}},{key:"getOpacity",value:function(){return this.options.opacity}},{key:"setOpacity",value:function(e){return this.getElement().style.opacity=this.options.opacity=e,e}},{key:"getZIndex",value:function(){return this.options.zIndex}},{key:"setZIndex",value:function(e){return this.getElement().style.zIndex=this.options.zIndex=e,e}},{key:"show",value:function(){this.options.visible||(this.options.visible=!0,this._map.on({zoom:this._onZoomVisible},this),this._onZoomVisible())}},{key:"hide",value:function(){if(this.options.visible){this.options.visible=!1,this._map.off(this.getEvents(),this),this._map.off({zoom:this._onZoomVisible},this);try{this._map.getPanes().overlayPane.removeChild(this.getElement())}catch(e){}}}}]),n}();function _(e){return new y(e)}t.CustomLayer=y,t.customLayer=_,e.CustomLayer=y,e.customLayer=_,e["default"]=_,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=Leaflet.CustomLayer.min.js.map
